<?php
$issuu_pdf_id = rex_request('issuu_pdf_id','int');
$func = rex_request('func','string');

$info = '';
$warning = '';

// delete issuu pdf
if($func == 'delete' && $issuu_pdf_id > 0) {
	$sql = rex_sql::factory();
	//  $sql->debugsql = true;
	$sql->setTable($REX['TABLE_PREFIX'] . '1016_issuu_pdfs');
	$sql->setWhere('id='. $issuu_pdf_id . ' LIMIT 1');

	if($sql->delete()) {
		$info = 'Issuu PDF wurde gel&ouml;scht.';
	} else {
		$warning = $sql->getErrro();
	}
	
	$func = '';
}

// output messages
if ($info != '') {
	echo rex_info($info);
}

if ($warning != '') {
	echo rex_warning($warning);
}

// output
echo '<div class="rex-addon-output-v2">';

if ($func == '') {
	$query = 'SELECT * FROM '.$REX['TABLE_PREFIX'].'1016_issuu_pdfs';

	$list = rex_list::factory($query);
	$list->setNoRowsMessage('Keine Issuu PDFs vorhanden');
	$list->setCaption('Liste der angelegten Issuu PDFs');
	$list->addTableAttribute('summary','Auflistung aller angelegten Issuu PDFs');
	$list->addTableColumnGroup(array(40, '*', 220, 100, 80, 80));

	$list->removeColumn('id');
	$list->removeColumn('view_id');
	$list->removeColumn('pdf_file');
	$list->removeColumn('document_id');
	$list->removeColumn('document_name');
	$list->removeColumn('timestamp');
	$list->removeColumn('description');
	$list->removeColumn('tags');
	$list->removeColumn('access');
	$list->setColumnLabel('id','ID');
	$list->setColumnLabel('title', 'Titel');
	$list->setColumnParams('title', array('func' => 'edit', 'issuu_pdf_id' => '###id###'));

	// icon column
	$thIcon = '<a class="rex-i-element rex-i-generic-add" href="'. $list->getUrl(array('func' => 'add')) .'"><span class="rex-i-element-text">Issuu PDF erstellen</span></a>';
	$tdIcon = '<span class="rex-i-element rex-i-generic"><span class="rex-i-element-text">###name###</span></span>';
	$list->addColumn($thIcon, $tdIcon, 0, array('<th class="rex-icon">###VALUE###</th>','<td class="rex-icon">###VALUE###</td>'));
	$list->setColumnParams($thIcon, array('func' => 'edit', 'issuu_pdf_id' => '###id###'));

	// file id column
	$pdfFile = 'PDF-Datei';
	$list->addColumn($pdfFile, '', -1, array('<th>###VALUE###</th>','<td>###VALUE###</td>'));
	$list->setColumnFormat($pdfFile, 'custom',
		create_function(
			'$params',
			'global $REX;
			$list = $params["list"];
		
			$media = OOMedia::getMediaByFilename($list->getValue("pdf_file"));
			if ($media) {
				return $media->getFileName();
			} else {
				return "Datei nicht gefunden!";
			}'
		)
	  );

	// viewer type column
	$viewerType = 'Ansicht';
	$list->addColumn($viewerType, '', -1, array('<th>###VALUE###</th>','<td>###VALUE###</td>'));
	$list->setColumnFormat($viewerType, 'custom',
		create_function(
			'$params',
			'global $REX;
			$list = $params["list"];

			$query =  \'SELECT name FROM \' . $REX[\'TABLE_PREFIX\'] . \'1016_views WHERE id=\' . $list->getValue("view_id");
			$sql = new sql();
			$sql->setQuery($query);
		
			$media = OOMedia::getMediaById($list->getValue("view_id"));
			if ($sql->getRows() == 0) {
				return "Viwer-Typ nicht mehr vorhanden!";
			} else {
				return $sql->getValue(\'name\');
			}'
		)
	  );

	// functions column spans 2 data-columns
	$funcs = 'Funktionen';
	$list->addColumn($funcs, 'bearbeiten', -1, array('<th colspan="2">###VALUE###</th>','<td>###VALUE###</td>'));
	$list->setColumnParams($funcs, array('func' => 'edit', 'issuu_pdf_id' => $issuu_pdf_id, 'issuu_pdf_id' => '###id###'));

	$delete = 'deleteCol';
	$list->addColumn($delete, 'l&ouml;schen', -1, array('','<td>###VALUE###</td>'));
	$list->setColumnParams($delete, array('issuu_pdf_id' => '###id###', 'func' => 'delete'));
	$list->addLinkAttribute($delete, 'onclick', 'alert(\'Bitte löschen Sie das Issuu PDF über die Bearbeitungsansicht.\r\n\r\nKlicken Sie dazu auf den Bearbeiten-Link und dann auf den Löschen-Button unten.\'); return false;');

	$list->show();
} elseif ($func == 'add' || $func == 'edit' && $issuu_pdf_id > 0) {
	if ($func == 'edit') {
		$formLabel = 'Issuu PDF bearbeiten';
	} else if ($func == 'add') {
		$formLabel = 'Issuu PDF erstellen';
	}

	$form = rex_form::factory($REX['TABLE_PREFIX'] . '1016_issuu_pdfs', $formLabel, 'id=' . $issuu_pdf_id);

	$form->addErrorMessage(REX_FORM_ERROR_VIOLATE_UNIQUE_KEY, 'Ein Issuu PDF mit dieser ID existiert bereits!');

	$field =& $form->addTextField('title'); 
	$field->setLabel('Titel');
	$field->setAttribute('id', 'title');

	$field =& $form->addTextField('description'); 
	$field->setLabel('Beschreibung');
	$field->setAttribute('id', 'description');

	$field =& $form->addTextField('tags'); 
	$field->setLabel('Schl&uuml;sselw&ouml;rter');
	$field->setAttribute('id', 'tags');

	$field =& $form->addSelectField('access'); 
	$field->setLabel('Zugriff');
	$field->setAttribute('id', 'access');
	$select =& $field->getSelect();
	$select->setSize(1);
	$select->addOption('privat', 'private');
	$select->addOption('&ouml;ffentlich', 'public');

	$field =& $form->addMediaField('pdf_file');
	$field->setLabel('PDF-Datei');

	$field =& $form->addSelectField('view_id'); 
	$field->setLabel('Ansicht');
	$select =& $field->getSelect();
	$select->setSize(1);
	$query = 'SELECT name as label,id FROM '.$REX['TABLE_PREFIX'].'1016_views';
	$select->addSqlOptions($query);

	$field =& $form->addReadOnlyField('document_id');
	$field->setLabel('Dokumenten-ID');
	$field->setAttribute('id', 'document_id_visible');

	$field =& $form->addReadOnlyField('status', 'Bereit');
	$field->setLabel('Status');
	$field->setAttribute('id', 'status');

	$field =& $form->addHiddenField('document_id');
	$field->setAttribute('id', 'document_id');

	$field =& $form->addHiddenField('document_name');
	$field->setAttribute('id', 'document_name');

	$field =& $form->addHiddenField('timestamp');
	$field->setAttribute('id', 'timestamp');
	
	// set buttons ids for jquery usage
	if ($func == 'add') {
		$key = 'Issuu PDF erstellen';
		
		$form->elements[$key][0]->saveElement->setAttribute('id', 'add_button_save');
		$form->elements[$key][0]->abortElement->setAttribute('id', 'add_button_abort');
	} elseif ($func == 'edit') {
		$key = 'Issuu PDF bearbeiten';
		
		$form->elements[$key][0]->deleteElement->setAttribute('onclick', 'return true;');
		$form->elements[$key][0]->deleteElement->setAttribute('id', 'edit_button_delete');
		$form->elements[$key][0]->saveElement->setAttribute('id', 'edit_button_save');
		$form->elements[$key][0]->applyElement->setAttribute('id', 'edit_button_apply');
		$form->elements[$key][0]->abortElement->setAttribute('id', 'edit_button_abort');
		
		$form->addParam('issuu_pdf_id', $issuu_pdf_id);
	}

	$form->show();
}

echo '</div>';

// hint: converting pdf to issuu pdf
if ($func == 'add' || $func == 'edit' && $issuu_pdf_id > 0) {
	echo '<div class="clearer"></div><p class="hint">Hinweis: Es kann mehrere Minuten dauern, bis das Issuu PDF auf Ihrer Website erscheint.</p>';
}
?>

<script type="text/javascript">
var $ = jQuery.noConflict();

var apiUrl = 'http://api.issuu.com/1_0';
var dataFormat = 'xml';
var doFinalSubmit = false;
var documentName = '';
var timeStamp = '';
var issuuDebug = '';
var $submitButton = null;
var $preloadedIcons = new Array();

$(document).ready(function() {
	// cache icons
	$preloadedIcons['loading'] = $('<img src="../files/addons/issuu_pdf_manager/icon_loading.gif" />');
	$preloadedIcons['success'] = $('<img src="../files/addons/issuu_pdf_manager/icon_success.png" />');
	$preloadedIcons['fail'] = $('<img src="../files/addons/issuu_pdf_manager/icon_fail.png" />');

	// manage upload
	$('#edit_button_save,#edit_button_apply,#add_button_save').click(function(e) {
		$submitButton = $(this);

		// check if pdf is selected
		if (!$('#REX_MEDIA_1').val()) {
			e.preventDefault();
			alert('Bitte wählen Sie zuerst ein PDF aus!');
			
			return false;
		}
		
		if (doFinalSubmit) {
			// do nothing, just go on with default behaviour
		} else {
			e.preventDefault();
			
			var queryStringUpload = generateUploadQueryString();
			
			if (queryStringUpload) {
				updateStatus('PDF auf dem Issuu-Server aktualisieren...', 'loading');
				
				if ($('#document_id').val() === '') {
					// document will be uploaded first time
					doUpload(queryStringUpload);
				} else {
					// first try delete...
					$.ajax({
						type: "POST",
						url: apiUrl,
						dataType: dataFormat,
						data: generateDeleteQueryString(false), // if pdf is updated on server (delete then upload) don't populate debug var
						complete:  function() {
							// ...then upload
							doUpload(queryStringUpload);
						}
					}); 
				}
			}
		}
	});
	
	// manage delete
	$('#edit_button_delete').click(function(e) {
		$submitButton = $(this);
		
		if (doFinalSubmit) {
			// do nothing, just go on with default behaviour
		} else {
			e.preventDefault();
			
			if (!confirm('Soll das Issuu PDF wirklich gelöscht werden?')) {
				return flase;
			}
			
			// first delete issuu pdf on issuu-server
			var queryString;
			
			if (queryString = generateDeleteQueryString()) {
				updateStatus('PDF auf dem Issuu-Server l&ouml;schen...', 'loading');

				$.ajax({
					type: "POST",
					url: apiUrl,
					dataType: dataFormat,
					data: queryString,
					error:  processDelete,
					success: processDelete
				});
				
			}
		}
	});	
});

function doUpload(queryString) {
	updateStatus('PDF auf den Issuu-Server &uuml;bertragen...', 'loading');
	
	$.ajax({
		type: "POST",
		url: apiUrl,
		dataType: dataFormat,
		data: queryString,
		error:  processUpload,
		success: processUpload
	});
}

function processUpload(xml) {
	//alert(XMLtoString(xml));
	
	var $xml = $(xml);
	var response = $xml.find('rsp').attr('stat');
	
	if (response === 'ok') {
		doFinalSubmit = true;
		updateStatus('...erfolgreich!', 'success');
		updateFormValues($xml.find('document').attr('documentId'));
		$submitButton.click();
	} else {
		updateStatus('Es ist ein Fehler beim Upload aufgetreten. <a href="javascript:alert(issuuDebug);">Statusbericht anzeigen</a>', 'fail');
	}
}

function processDelete(xml) {
	//alert(XMLtoString(xml));
	
	var $xml = $(xml);
	var response = $xml.find('rsp').attr('stat');
	
	if (response === 'ok') {
		doFinalSubmit = true;
		updateStatus('...erfolgreich!', 'success');
		$submitButton.click();
	} else {
		updateStatus('Es ist ein Fehler beim L&ouml;schen aufgetreten. <a href="javascript:alert(issuuDebug);">Statusbericht anzeigen</a>', 'fail');
	}
}

function updateStatus(msg, icon) {
	// todo: merge with existing icons array used for preloading
	var icons = new Array();
	
	icons['loading'] = 'icon_loading.gif';
	icons['success'] = 'icon_success.png';
	icons['fail'] = 'icon_fail.png';

	html = '<img src="../files/addons/issuu_pdf_manager/' + icons[icon] + '" width="16" height="16" alt="" /> ' + msg;

	$('#status').html(html);
}

function updateFormValues(id) {
	$('#document_id').val(id);
	$('#document_id_visible').text(id);
	
	$('#document_name').val(documentName);
	$('#timestamp').val(timeStamp);
}

function sign(secretKey, params, makeMD5) {
	if (makeMD5 == null){
		makeMD5 = true;
	}
	
	var signature = secretKey;

	for (i = 0; i < params.length; i++) {
		signature += params[i];
	}
	
	if (makeMD5) {
		return md5(signature);
	} else {
		return signature;
	}
}

function XMLtoString(elem) {
	var serialized;
	
	try {
		// XMLSerializer exists in current Mozilla browsers
		serializer = new XMLSerializer();
		serialized = serializer.serializeToString(elem);
	} catch (e) {
		// Internet Explorer has a different approach to serializing XML
		serialized = elem.xml;
	}
	
	return serialized;
}

function getTimeStamp(md5) {
	if (md5 == null){
		md5 = false;
	}

	timeStamp = Math.round((new Date()).getTime() / 1000);
	
	if (md5) {
		return md5(timeStamp + "");
	} else {
		return timeStamp;
	}
}

function splitString(string, strPos) {
	var part1 = string.substr(0, strPos);
	var part2 = string.substr(strPos);
	return part1 + "\r\n" + part2;
}

var timeFormat = {
    displayFormat: 'd.m.Y - H:i:s',
 
    format: function(timestamp) {
        // convert unix timestamp to javascript date object
        var d = new Date(timestamp * 1000);
        var output = this.displayFormat;
		
        output = output.replace(/d/g, this.padZero(d.getDate()))
            .replace(/m/g, this.padZero(d.getMonth() + 1))
            .replace(/Y/g, d.getFullYear())
            .replace(/H/g, this.padZero(d.getHours()))
            .replace(/i/g, this.padZero(d.getMinutes()))
            .replace(/s/g, this.padZero(d.getSeconds()));
        return output;
    },
 
    padZero: function(number) {
        if (number < 10) {
            return "0" + number.toString();
        }
 
        return number;
    }
}; 

<?php
if ($REX['ADDON']['issuu_pdf_manager']['website_url_mode'] == 'rex_server' && containsString(strtolower($REX['SERVER']), 'http://')) {
	$websiteURL = $REX['SERVER'];
} elseif ($REX['ADDON']['issuu_pdf_manager']['website_url_mode'] == 'userdef' && $REX['ADDON']['issuu_pdf_manager']['website_url'] != '' && strtolower($REX['ADDON']['issuu_pdf_manager']['website_url']) != 'http://') {
	$websiteURL = $REX['ADDON']['issuu_pdf_manager']['website_url'];
} else {
	$websiteURL = 'http://' . $_SERVER['SERVER_NAME'] . '/';
}
?>

function generateUploadQueryString() {
	var curTimestamp = getTimeStamp();
	var curFile = $('#REX_MEDIA_1').val();
	var curRootPath = "<?php echo rtrim($websiteURL, '/') . '/'; ?>";
	var curFilesPath = curRootPath + 'files/';
	var curTitle = $('#title').val();

	if (curTitle === '') {
		// if title not specified use filename as title for issuu api
		curTitle = curFile.replace(".pdf", "");
	}

	var tags = $('#tags').val();
	var description = $('#description').val();
	var access = $('#access').val();

	var infoLink = <?php if ($REX['ADDON']['issuu_pdf_manager']['info_link'] == 1) { echo 'curRootPath'; } else { echo '""'; } ?>;
	var commentsAllowed = "<?php if ($REX['ADDON']['issuu_pdf_manager']['comments'] == 1) { echo 'true'; } else { echo 'false'; } ?>";
	var ratingsAllowed = "<?php if ($REX['ADDON']['issuu_pdf_manager']['rating'] == 1) { echo 'true'; } else { echo 'false'; } ?>";
	var downloadable = "<?php if ($REX['ADDON']['issuu_pdf_manager']['download'] == 1) { echo 'true'; } else { echo 'false'; } ?>";

	var apiKey = "<?php echo $REX['ADDON']['issuu_pdf_manager']['api_key']; ?>";
	var apiSecret = "<?php echo $REX['ADDON']['issuu_pdf_manager']['api_secret']; ?>";

	var format = dataFormat;
	var action = 'issuu.document.url_upload';
	var name = curTimestamp + ""; // timestamp used for having an absolute unique name 
	var title = curTitle; // + " " + timeFormat.format(curTimestamp)

	var slurpUrl = curFilesPath + curFile + '?' + curTimestamp; // unique id neccessary, as otherwise file with same name wont get updated 

	var paramsToSign = new Array('access' , access, 'action', action, 'apiKey', apiKey, 'commentsAllowed', commentsAllowed, 'description', description, 'downloadable', downloadable, 'format', format, 'infoLink', infoLink, 'name', name, 'ratingsAllowed', ratingsAllowed, 'slurpUrl', slurpUrl, 'tags', tags, 'title', title);
	var signature = sign(apiSecret, paramsToSign);
	
	// this is for redaxo to save generated values in db, see updateFormValues function
	documentName = name;
	timeStamp = curTimestamp + "";
						
	// generate query string
	var queryString = 'access' + '=' + access + '&' +
					  'action' + '=' + action + '&' +
					  'apiKey' + '=' + apiKey + '&' +
					  'commentsAllowed' + '=' + commentsAllowed + '&' +
					  'description' + '=' + description + '&' +
					  'downloadable' + '=' + downloadable + '&' +
					  'format' + '=' + format + '&' +
					  'infoLink' + '=' + infoLink + '&' +
					  'name' + '=' + name + '&' +
					  'ratingsAllowed' + '=' + ratingsAllowed + '&' +
					  'slurpUrl' + '=' + slurpUrl + '&' +
					  'tags' + '=' + tags + '&' +
					  'title' + '=' + title + '&' +
					  'signature' + '=' + signature;

	// global debug var
	issuuDebug = '*** DEBUG BEGIN ***' + "\r\n" + "\r\n" +
				 'curTimestamp: ' + curTimestamp + "\r\n" +
				 'curFile: ' + curFile + "\r\n" +
				 'curTitle: ' + curTitle + "\r\n" +
				 'curRootPath: ' + curRootPath + "\r\n" +
				 'curFilesPath: ' + curFilesPath + "\r\n" + "\r\n";
				
	var replacer = new RegExp("&", "g");
	var queryParams = queryString.replace(replacer, "\r\n");
	
	replacer = new RegExp("=", "g");
	queryParams = queryParams.replace(replacer, ": ");
	
	issuuDebug += queryParams + "\r\n" + "\r\n";
				
	issuuDebug += 'signatureString: ' + splitString(sign(apiSecret, paramsToSign, false), 120) + "\r\n" + "\r\n" +
				  '*** DEBUG END ***';
	
	// if debug mode don't submit form. instead show alert with debug message			  
	if (<?php echo $REX['ADDON']['issuu_pdf_manager']['debug_mode']; ?> == 1) {
		alert(issuuDebug);
		return '';
	}

	return queryString;
}

function generateDeleteQueryString(debug) {
	if (debug == null){
		debug = true;
	}
	
	var apiKey = "<?php echo $REX['ADDON']['issuu_pdf_manager']['api_key']; ?>";
	var apiSecret = "<?php echo $REX['ADDON']['issuu_pdf_manager']['api_secret']; ?>";

	var format = dataFormat;
	var action = 'issuu.document.delete';
	var names = $('#document_name').val(); 
	
	var paramsToSign = new Array('action', action, 'apiKey', apiKey, 'format', format, 'names', names);
	var signature = sign(apiSecret, paramsToSign);
						
	// generate query string
	var queryString = 'action' + '=' + action + '&' +
					  'apiKey' + '=' + apiKey + '&' +
				  	  'format' + '=' + format + '&' +
				  	  'names' + '=' + names + '&' +
				  	  'signature' + '=' + signature;

	// global debug var
	if (debug) {
		issuuDebug = '*** DEBUG BEGIN ***' + "\r\n" + "\r\n";
					
		var replacer = new RegExp("&", "g");
		var queryParams = queryString.replace(replacer, "\r\n");
		
		replacer = new RegExp("=", "g");
		queryParams = queryParams.replace(replacer, ": ");
		
		issuuDebug += queryParams + "\r\n" + "\r\n";
					
		issuuDebug += '*** DEBUG END ***';
		
		// if debug mode don't submit form. instead show alert with debug message			  
		if (<?php echo $REX['ADDON']['issuu_pdf_manager']['debug_mode']; ?> == 1) {
			alert(issuuDebug);
			return '';
		}
	}

	return queryString;
}
</script>
