<?php
// Daten einlesen
$moduleInput = rex_get_file_contents($REX["INCLUDE_PATH"] . "/addons/issuu_pdf_manager/module/input.php");
$moduleOutput = rex_get_file_contents($REX["INCLUDE_PATH"] . "/addons/issuu_pdf_manager/module/output.php");

// Ist Modul schon vorhanden ?
$searchtext = 'module: issuu_pdf_manager_default_out';

$gm = rex_sql::factory();
$gm->setQuery('select * from ' . $REX['TABLE_PREFIX'] . 'module where ausgabe LIKE "%' . $searchtext . '%"');

$module_id = 0;
$module_name = "";

foreach($gm->getArray() as $module) {
  $module_id = $module["id"];
  $module_name = $module["name"];
}

if (isset($_REQUEST["install"]) && $_REQUEST["install"] == 1) {
  $issuu_pdf_manager_module_name = "Issuu PDF";

  $mi = rex_sql::factory();
  // $mi->debugsql = 1;
  $mi->setTable("rex_module");
  $mi->setValue("eingabe", addslashes($moduleInput));
  $mi->setValue("ausgabe", addslashes($moduleOutput));

  if (isset($_REQUEST["module_id"]) && $module_id == $_REQUEST["module_id"]) {
	// altes Module aktualisieren
    $mi->setWhere('id="' . $module_id . '"');
    $mi->update();

 	// article updaten
	rex_generateAll();
	
    echo rex_info($I18N->msg('module_updated').' | '.$I18N->msg('delete_cache_message'));
  }else {
	// neues Modul einf&uuml;gen
    $mi->setValue("name", $issuu_pdf_manager_module_name);
    $mi->insert();
    $module_id = (int) $mi->getLastId();
	
    echo rex_info('Modul "' . $issuu_pdf_manager_module_name . '" wurde angelegt');
  }
}
?>

<div class="rex-addon-output">
	<h2 class="rex-hl2">Einrichtung</h2>
	<div class="rex-area-content">
		<p>Um dieses Addon mit dem Issuu-Service benutzen zu k&ouml;nnen, m&uuml;ssen Sie folgende Schritte durchf&uuml;hren:</p>
		<ol>
			<li>Tragen Sie unter <a href="index.php?page=issuu_pdf_manager&subpage=settings">Einstellungen</a> Ihren <strong>API-Key</strong> sowie <strong>API-Secret</strong> ein. Beides k&ouml;nnen Sie bei <a href="http://issuu.com/user/settings?services=true#services" target="_blank">Issuu.com</a> erhalten (Reiter "Services"). Evtl. m&uuml;ssen Sie sich dort vorher <a href="http://issuu.com/signup" target="_blank">neu registrieren</a>. </li>
			<li>&uuml;berpr&uuml;fen Sie, ob die vollst&auml;ndige <strong>URL Ihrer Website</strong> unter <a href="index.php?page=specials">System</a> und dann $REX['SERVER'] steht, also inkl. http:// und evtl. Unterverzeichnis. Alternativ k&ouml;nnen Sie Ihre Website URL auch unter den <a href="index.php?page=issuu_pdf_manager&subpage=settings">Einstellungen</a> eintragen.</li>
			<li>F&uuml;gen Sie das untenstehende <strong>Modul</strong> hinzu.</li>
		</ol>
		<p>Das war's. Sie k&ouml;nnen jetzt &uuml;ber den Issuu PDF Manager sog. Issuu PDFs hinzuf&uuml;gen und dann an passender Stelle in einem Artikel &uuml;ber das installierte Modul ausgeben.</p>
		<ol></ol>
		<p>
			<strong>Hinweis f&uuml;r Entwickler:</strong> Wenn Sie einen lokalen Webserver einsetzen (wie z.B. XAMPP), wird die Upload-Funktion NICHT funktionieren auch wenn die Issuu-API und somit das Addon keinen Fehler meldet!   
		</p>
	</div>
</div>

<div class="rex-addon-output">
	<h2 class="rex-hl2">Modul</h2>
	<div class="rex-area-content">
		<p>Dieses Modul wird ben&ouml;tigt um die angelegten Issuu PDFs ausw&auml;hlen und anzeigen zu k&ouml;nnen. </p>
		<ul>
		<?php
			if ($module_id > 0) {
				if (!isset($_REQUEST["install"])) {
					echo '<li><a href="index.php?page=issuu_pdf_manager&amp;subpage=setup&amp;install=1&amp;module_id=' . $module_id . '">Bestehendes Modul aktualisieren</a></li>';
				}
    		} else {
				if (!isset($_REQUEST["install"])) {
					echo '<li><a href="index.php?page=issuu_pdf_manager&amp;subpage=setup&amp;install=1">Modul jetzt automatisch installieren</a></li>';
				}
			}
		?>		
		</ul>
		<p>Eingabe:<br /><?php rex_highlight_string($moduleInput); ?></p>
		<p>&nbsp;</p>
		<p>Ausgabe:<br /><?php rex_highlight_string($moduleOutput); ?></p>
	</div>
</div>
