<?php

$layoutModes['single_page'] = 'Einzelne Seite';
$layoutModes['double_page'] = 'Doppelseite';

$view_id = rex_request('view_id','int');
$func = rex_request('func','string');

$info = '';
$warning = '';

// delete view
if($func == 'delete' && $view_id > 0) {
	$sql = rex_sql::factory();
	//  $sql->debugsql = true;
	$sql->setTable($REX['TABLE_PREFIX'] . '1016_views');
	$sql->setWhere('id='. $view_id . ' LIMIT 1');

	if($sql->delete()) {
		$info = 'Ansicht wurde gel&ouml;scht.';
	} else {
		$warning = $sql->getErrro();
	}
	
	$func = '';
}

// output messages
if ($info != '') {
	echo rex_info($info);
}

if ($warning != '') {
	echo rex_warning($warning);
}

// output
echo '<div class="rex-addon-output-v2">';

if ($func == '') {
	$query = 'SELECT * FROM '.$REX['TABLE_PREFIX'].'1016_views';

	$list = rex_list::factory($query);
	$list->setNoRowsMessage('Keine Ansichten vorhanden');
	$list->setCaption('Liste der angelegten Ansichten');
	$list->addTableAttribute('summary','Auflistung aller angelegten Ansichten');
	$list->addTableColumnGroup(array(40, '*', 160, 80, 80, 80, 80));

	$list->removeColumn('id');
	$list->removeColumn('color');
	$list->removeColumn('page_number');
	$list->removeColumn('show_title');
	$list->removeColumn('show_social');
	$list->removeColumn('layout');
	$list->removeColumn('width');
	$list->removeColumn('height');
	$list->setColumnLabel('id','ID');
	$list->setColumnLabel('name', 'Name');
	$list->setColumnLabel('layout', 'Layout');
	$list->setColumnLabel('width', 'Breite');
	$list->setColumnLabel('height', 'H&ouml;he');
	$list->setColumnParams('name', array('func' => 'edit', 'view_id' => '###id###'));

	// icon column
	$thIcon = '<a class="rex-i-element rex-i-generic-add" href="'. $list->getUrl(array('func' => 'add')) .'"><span class="rex-i-element-text">Ansicht erstellen</span></a>';
	$tdIcon = '<span class="rex-i-element rex-i-generic"><span class="rex-i-element-text">###name###</span></span>';
	$list->addColumn($thIcon, $tdIcon, 0, array('<th class="rex-icon">###VALUE###</th>','<td class="rex-icon">###VALUE###</td>'));
	$list->setColumnParams($thIcon, array('func' => 'edit', 'view_id' => '###id###'));

	// layout column
	$layout = 'Layout';
	$list->addColumn($layout, '', -1, array('<th>###VALUE###</th>','<td>###VALUE###</td>'));
	$list->setColumnFormat($layout, 'custom',
		create_function(
			'$params',
			'global $REX;
			global $layoutModes;
			$list = $params["list"];
			
			return $layoutModes[$list->getValue("layout")];
			'
		)
	  );

	// width column
	$width = 'Breite';
	$list->addColumn($width, '', -1, array('<th>###VALUE###</th>','<td>###VALUE###</td>'));
	$list->setColumnFormat($width, 'custom',
		create_function(
			'$params',
			'global $REX;
			$list = $params["list"];
			
			return $list->getValue("width");
			'
		)
	  );

	// height column
	$height = 'H&ouml;he';
	$list->addColumn($height, '', -1, array('<th>###VALUE###</th>','<td>###VALUE###</td>'));
	$list->setColumnFormat($height, 'custom',
		create_function(
			'$params',
			'global $REX;
			$list = $params["list"];
			
			return $list->getValue("height");
			'
		)
	  );

	// functions column spans 2 data-columns
	$funcs = 'Funktionen';
	$list->addColumn($funcs, 'bearbeiten', -1, array('<th colspan="2">###VALUE###</th>','<td>###VALUE###</td>'));
	$list->setColumnParams($funcs, array('func' => 'edit', 'view_id' => $view_id, 'view_id' => '###id###'));

	$delete = 'deleteCol';
	$list->addColumn($delete, 'l&ouml;schen', -1, array('','<td>###VALUE###</td>'));
	$list->setColumnParams($delete, array('view_id' => '###id###', 'func' => 'delete'));
	$list->addLinkAttribute($delete, 'onclick', 'return confirm(\''.$I18N->msg('delete').' ?\')');

	$list->show();
} elseif ($func == 'add' || $func == 'edit' && $view_id > 0) {
	if ($func == 'edit') {
		$formLabel = 'Ansicht bearbeiten';
	} else if ($func == 'add') {
		$formLabel = 'Ansicht erstellen';
	}

	$form = rex_form::factory($REX['TABLE_PREFIX'] . '1016_views', $formLabel, 'id=' . $view_id);

	$form->addErrorMessage(REX_FORM_ERROR_VIOLATE_UNIQUE_KEY, 'Ein Ansicht mit dieser ID existiert bereits!');

	$field =& $form->addTextField('name');
	$field->setLabel('Name');

	$field =& $form->addSelectField('layout'); 
	$field->setLabel('Layout');
	$select =& $field->getSelect();
	$select->setSize(1);
	$select->addOption($layoutModes['single_page'], 'single_page');
	$select->addOption($layoutModes['double_page'], 'double_page');

	$field =& $form->addTextField('width');
	$field->setLabel('Breite');

	$field =& $form->addTextField('height');
	$field->setLabel('H&ouml;he');

	$field =& $form->addTextField('color');
	$field->setLabel('Farbwert (hex)');

	$field =& $form->addTextField('page_number', '1');
	$field->setLabel('Seiten-Nr. anzeigen');

	$field =& $form->addSelectField('show_title'); 
	$field->setLabel('Titel und Autor anzeigen');
	$select =& $field->getSelect();
	$select->setSize(1);
	$select->addOption('Nein', 0);
	$select->addOption('Ja', 1);

	$field =& $form->addSelectField('show_social'); 
	$field->setLabel('Social-Menu anzeigen');
	$select =& $field->getSelect();
	$select->setSize(1);
	$select->addOption('Nein', 0);
	$select->addOption('Ja', 1);

	if($func == 'edit') {
		$form->addParam('view_id', $view_id);
	}

	$form->show();
}

echo '</div>';
?>
